--- src/backend/access/nbtree/nbtpage.c.orig	2014-08-18 14:10:36.845016657 -0400
+++ src/backend/access/nbtree/nbtpage.c	2014-08-19 16:56:13.967198176 -0400
@@ -127,7 +127,11 @@ _bt_getroot(Relation rel, int access)
 		Assert(rootblkno != P_NONE);
 		rootlevel = metad->btm_fastlevel;
 
-		rootbuf = _bt_getbuf(rel, rootblkno, BT_READ);
+		rootbuf = _bt_getbuf(rel, rootblkno, BT_READ
+#ifdef USE_PREFETCH
+                                     , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                            );
 		rootpage = BufferGetPage(rootbuf);
 		rootopaque = (BTPageOpaque) PageGetSpecialPointer(rootpage);
 
@@ -153,7 +157,11 @@ _bt_getroot(Relation rel, int access)
 		rel->rd_amcache = NULL;
 	}
 
-	metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_READ);
+	metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_READ
+#ifdef USE_PREFETCH
+                                     , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                        );
 	metapg = BufferGetPage(metabuf);
 	metaopaque = (BTPageOpaque) PageGetSpecialPointer(metapg);
 	metad = BTPageGetMeta(metapg);
@@ -209,7 +217,11 @@ _bt_getroot(Relation rel, int access)
 		 * the new root page.  Since this is the first page in the tree, it's
 		 * a leaf as well as the root.
 		 */
-		rootbuf = _bt_getbuf(rel, P_NEW, BT_WRITE);
+		rootbuf = _bt_getbuf(rel, P_NEW, BT_WRITE
+#ifdef USE_PREFETCH
+                                     , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                            );
 		rootblkno = BufferGetBlockNumber(rootbuf);
 		rootpage = BufferGetPage(rootbuf);
 		rootopaque = (BTPageOpaque) PageGetSpecialPointer(rootpage);
@@ -350,7 +362,11 @@ _bt_gettrueroot(Relation rel)
 		pfree(rel->rd_amcache);
 	rel->rd_amcache = NULL;
 
-	metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_READ);
+	metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_READ
+#ifdef USE_PREFETCH
+                                     , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                        );
 	metapg = BufferGetPage(metabuf);
 	metaopaque = (BTPageOpaque) PageGetSpecialPointer(metapg);
 	metad = BTPageGetMeta(metapg);
@@ -436,7 +452,11 @@ _bt_getrootheight(Relation rel)
 		Page		metapg;
 		BTPageOpaque metaopaque;
 
-		metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_READ);
+		metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_READ
+#ifdef USE_PREFETCH
+                                     , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                             );
 		metapg = BufferGetPage(metabuf);
 		metaopaque = (BTPageOpaque) PageGetSpecialPointer(metapg);
 		metad = BTPageGetMeta(metapg);
@@ -561,6 +581,172 @@ _bt_log_reuse_page(Relation rel, BlockNu
 	END_CRIT_SECTION();
 }
 
+#ifdef USE_PREFETCH
+/*
+ *	_bt_prefetchbuf() -- Prefetch a buffer by block number
+ *                           and keep track of prefetched and unread blocknums in pagelist.
+ *   input parms  :
+ *       rel and blockno identify block to be prefetched as usual
+ *       pfch_index_page_list_P points to the pointer anchoring the head of the index page list
+ *             Since the pagelist is a kind of optimization,
+ *             handle palloc failure by quietly omitting the keeping track.
+ */
+void
+_bt_prefetchbuf(Relation rel, BlockNumber blkno , struct pfch_index_pagelist** pfch_index_page_list_P)
+{
+
+    int rc = 0;
+    struct pfch_index_pagelist* pfch_index_plp;      /*  pointer to current chunk */
+    struct pfch_index_item* found_item = 0;
+
+		if ((struct pfch_index_pagelist**)0 == pfch_index_page_list_P) {
+			pfch_index_plp = (struct pfch_index_pagelist*)0;
+		} else {
+			pfch_index_plp = *pfch_index_page_list_P;
+		}
+
+    	if (blkno != P_NEW && blkno != P_NONE)
+    	{
+            /* prefetch an existing block of the relation
+            ** but first,  check it has not recently already been prefetched and not yet read
+            */
+            found_item = _bt_find_block(blkno , pfch_index_plp);
+			if ((struct pfch_index_item*)0 == found_item) {  /*  not found */
+
+		        rc = PrefetchBuffer(rel, MAIN_FORKNUM, blkno , 0);
+
+                /*  add the pagenum to the list ,  indicating its discard status
+                **  since it's only an optimization,  ignore failure such as exceeded allowed space
+				*/
+                _bt_add_block( blkno , pfch_index_page_list_P , (uint32)(rc & PREFTCHRC_BUF_PIN_INCREASED));
+
+            }
+	    }
+        return;
+}
+
+/*   _bt_find_block finds the item referencing specified Block in index page list if present
+**   and returns the pointer to the pfch_index_item if found,  or null if not
+*/
+struct pfch_index_item*
+_bt_find_block(BlockNumber blkno , struct pfch_index_pagelist* pfch_index_page_list)
+{
+
+    struct pfch_index_item* found_item = 0;
+    struct pfch_index_pagelist* pfch_index_plp;      /*  pointer to current chunk */
+    int ix, tx;
+
+		pfch_index_plp = pfch_index_page_list;
+
+		while (     (struct pfch_index_pagelist*)0 != pfch_index_plp
+                &&  ( (struct pfch_index_item*)0 == found_item)
+              ) {
+			ix = 0;
+			tx = pfch_index_plp->pfch_index_item_count;
+			while (     (ix < tx)
+                    &&  ( (struct pfch_index_item*)0 == found_item)
+                  ) {
+				if (pfch_index_plp->pfch_indexid[ix].pfch_blocknum == blkno) {
+					found_item = &pfch_index_plp->pfch_indexid[ix];
+				}
+                ix++;
+			}
+			pfch_index_plp = pfch_index_plp->pfch_index_pagelist_next;
+		}
+
+     return found_item;
+}
+
+/*   _bt_add_block adds the specified Block to the index page list
+**   and returns 0 if successful,  non-zero if not
+*/
+int
+_bt_add_block(BlockNumber blkno , struct pfch_index_pagelist** pfch_index_page_list_P , uint32 discard_status)
+{
+    int rc = 1;
+    int ix;
+    struct pfch_index_pagelist* pfch_index_plp;      /*  pointer to current chunk */
+    struct pfch_index_pagelist* pfch_index_page_list_anchor; /*  pointer to first chunk if any  */
+	/*  allow expansion of pagelist to 16 chunks
+	**  which accommodates backwards-sequential index scans
+	**  where the scanner increases target_prefetch_pages by a factor of up to 16
+	**   see code in _bt_steppage
+	**  note - this creates an undesirable weak dependency on this number in _bt_steppage,
+	**         but :
+	**           there is no disaster if the numbers disagree  -  just sub-optimal use of the list
+	**           to implement a proper interface would require that chunks have a variable size
+	**           which would require an extra size variable in each chunk
+	*/
+	int num_chunks = 16;
+
+		if ((struct pfch_index_pagelist**)0 == pfch_index_page_list_P) {
+			pfch_index_page_list_anchor = (struct pfch_index_pagelist*)0;
+		} else {
+			pfch_index_page_list_anchor = *pfch_index_page_list_P;
+		}
+		pfch_index_plp = pfch_index_page_list_anchor;       /* pointer to current chunk */
+
+		while ( (struct pfch_index_pagelist*)0 != pfch_index_plp ) {
+			ix = pfch_index_plp->pfch_index_item_count;
+			if (ix < target_prefetch_pages) {
+				pfch_index_plp->pfch_indexid[ix].pfch_blocknum = blkno;
+				pfch_index_plp->pfch_indexid[ix].pfch_discard = discard_status;
+				pfch_index_plp->pfch_index_item_count = (ix+1);
+                rc = 0;
+				goto stored_pagenum;
+			}
+			pfch_index_plp = pfch_index_plp->pfch_index_pagelist_next;
+			num_chunks--;              /*  keep track of number of chunks */
+		}
+
+		/*   we did not find any free space in existing chunks -
+		**   create new chunk if within our limit and we have a pfch_index_page_list
+		*/
+		if ( (num_chunks > 0) && ((struct pfch_index_pagelist*)0 != pfch_index_page_list_anchor) ) {
+			pfch_index_plp = (struct pfch_index_pagelist*)palloc( sizeof(struct pfch_index_pagelist) + ( (target_prefetch_pages-1) * sizeof(struct pfch_index_item) ) );
+			if ( (struct pfch_index_pagelist*)0 != pfch_index_plp ) {
+				pfch_index_plp->pfch_index_pagelist_next = pfch_index_page_list_anchor;  /* old head of list is next after this */
+				pfch_index_plp->pfch_indexid[0].pfch_blocknum = blkno;
+				pfch_index_plp->pfch_indexid[0].pfch_discard = discard_status;
+				pfch_index_plp->pfch_index_item_count = 1;
+				pfch_index_page_list_P = &pfch_index_plp;   /*  new head of list is new chunk */
+                rc = 0;
+			}
+		}
+
+    stored_pagenum:;
+     return rc;
+}
+
+/*  _bt_subtract_block removes a block from the prefetched-but-unread pagelist if present */
+void
+_bt_subtract_block(BlockNumber blkno , struct pfch_index_pagelist* pfch_index_page_list)
+{
+    struct pfch_index_pagelist* pfch_index_plp = pfch_index_page_list;
+	if ( (blkno != P_NEW) && (blkno != P_NONE) ) {
+            int ix , jx;
+                while ( (struct pfch_index_pagelist*)0 != pfch_index_plp ) {
+                    ix = pfch_index_plp->pfch_index_item_count;
+                    while (ix-- > 0) {
+                        if (pfch_index_plp->pfch_indexid[ix].pfch_blocknum == blkno) {
+                            /*   move the last item to the curent (now deleted) position and decrement count */
+                            jx = (pfch_index_plp->pfch_index_item_count-1); /*  index of last item ... */
+                            if (jx > ix) {                                  /*  ... is not the current one so move is required */
+                                pfch_index_plp->pfch_indexid[ix].pfch_blocknum = pfch_index_plp->pfch_indexid[jx].pfch_blocknum;
+                                pfch_index_plp->pfch_indexid[ix].pfch_discard = pfch_index_plp->pfch_indexid[jx].pfch_discard;
+                                ix = jx;
+                            }
+                            pfch_index_plp->pfch_index_item_count = ix;
+                            goto done_subtract;
+                        }
+                    }
+                    pfch_index_plp = pfch_index_plp->pfch_index_pagelist_next;
+                }
+        }
+    done_subtract:  return;
+}
+#endif /* USE_PREFETCH */
+
 /*
  *	_bt_getbuf() -- Get a buffer by block number for read or write.
  *
@@ -573,7 +759,11 @@ _bt_log_reuse_page(Relation rel, BlockNu
  *		_bt_checkpage to sanity-check the page (except in P_NEW case).
  */
 Buffer
-_bt_getbuf(Relation rel, BlockNumber blkno, int access)
+_bt_getbuf(Relation rel, BlockNumber blkno, int access
+#ifdef USE_PREFETCH
+                              ,struct pfch_index_pagelist* pfch_index_page_list
+#endif /* USE_PREFETCH */
+          )
 {
 	Buffer		buf;
 
@@ -581,6 +771,12 @@ _bt_getbuf(Relation rel, BlockNumber blk
 	{
 		/* Read an existing block of the relation */
 		buf = ReadBuffer(rel, blkno);
+
+#ifdef USE_PREFETCH
+        /*  if the block is in the prefetched-but-unread pagelist,  remove it */
+        _bt_subtract_block( blkno , pfch_index_page_list);
+#endif /* USE_PREFETCH */
+
 		LockBuffer(buf, access);
 		_bt_checkpage(rel, buf);
 	}
@@ -702,6 +898,10 @@ _bt_getbuf(Relation rel, BlockNumber blk
  * bufmgr when one would do.  However, now it's mainly just a notational
  * convenience.  The only case where it saves work over _bt_relbuf/_bt_getbuf
  * is when the target page is the same one already in the buffer.
+ *
+ * if prefetching of index pages is changed to use this function,
+ * then it should be extended to take the index_page_list as parameter
+ * and call_bt_subtract_block in the same way that _bt_getbuf does.
  */
 Buffer
 _bt_relandgetbuf(Relation rel, Buffer obuf, BlockNumber blkno, int access)
@@ -712,6 +912,7 @@ _bt_relandgetbuf(Relation rel, Buffer ob
 	if (BufferIsValid(obuf))
 		LockBuffer(obuf, BUFFER_LOCK_UNLOCK);
 	buf = ReleaseAndReadBuffer(obuf, rel, blkno);
+
 	LockBuffer(buf, access);
 	_bt_checkpage(rel, buf);
 	return buf;
@@ -965,7 +1166,11 @@ _bt_is_page_halfdead(Relation rel, Block
 	BTPageOpaque opaque;
 	bool		result;
 
-	buf = _bt_getbuf(rel, blk, BT_READ);
+	buf = _bt_getbuf(rel, blk, BT_READ
+#ifdef USE_PREFETCH
+                                     , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                     );
 	page = BufferGetPage(buf);
 	opaque = (BTPageOpaque) PageGetSpecialPointer(page);
 
@@ -1069,7 +1274,11 @@ _bt_lock_branch_parent(Relation rel, Blo
 				Page		lpage;
 				BTPageOpaque lopaque;
 
-				lbuf = _bt_getbuf(rel, leftsib, BT_READ);
+				lbuf = _bt_getbuf(rel, leftsib, BT_READ
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                                 );
 				lpage = BufferGetPage(lbuf);
 				lopaque = (BTPageOpaque) PageGetSpecialPointer(lpage);
 
@@ -1265,7 +1474,11 @@ _bt_pagedel(Relation rel, Buffer buf)
 					BTPageOpaque lopaque;
 					Page		lpage;
 
-					lbuf = _bt_getbuf(rel, leftsib, BT_READ);
+					lbuf = _bt_getbuf(rel, leftsib, BT_READ
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                                     );
 					lpage = BufferGetPage(lbuf);
 					lopaque = (BTPageOpaque) PageGetSpecialPointer(lpage);
 					/*
@@ -1340,7 +1553,11 @@ _bt_pagedel(Relation rel, Buffer buf)
 		if (!rightsib_empty)
 			break;
 
-		buf = _bt_getbuf(rel, rightsib, BT_WRITE);
+		buf = _bt_getbuf(rel, rightsib, BT_WRITE
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                        );
 	}
 
 	return ndeleted;
@@ -1593,7 +1810,11 @@ _bt_unlink_halfdead_page(Relation rel, B
 		target = topblkno;
 
 		/* fetch the block number of the topmost parent's left sibling */
-		buf = _bt_getbuf(rel, topblkno, BT_READ);
+		buf = _bt_getbuf(rel, topblkno, BT_READ
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                        );
 		page = BufferGetPage(buf);
 		opaque = (BTPageOpaque) PageGetSpecialPointer(page);
 		leftsib = opaque->btpo_prev;
@@ -1632,7 +1853,11 @@ _bt_unlink_halfdead_page(Relation rel, B
 		LockBuffer(leafbuf, BT_WRITE);
 	if (leftsib != P_NONE)
 	{
-		lbuf = _bt_getbuf(rel, leftsib, BT_WRITE);
+		lbuf = _bt_getbuf(rel, leftsib, BT_WRITE
+#ifdef USE_PREFETCH
+                                     , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                         );
 		page = BufferGetPage(lbuf);
 		opaque = (BTPageOpaque) PageGetSpecialPointer(page);
 		while (P_ISDELETED(opaque) || opaque->btpo_next != target)
@@ -1646,7 +1871,11 @@ _bt_unlink_halfdead_page(Relation rel, B
 					 RelationGetRelationName(rel));
 				return false;
 			}
-			lbuf = _bt_getbuf(rel, leftsib, BT_WRITE);
+			lbuf = _bt_getbuf(rel, leftsib, BT_WRITE
+#ifdef USE_PREFETCH
+                                     , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                              );
 			page = BufferGetPage(lbuf);
 			opaque = (BTPageOpaque) PageGetSpecialPointer(page);
 		}
@@ -1701,7 +1930,11 @@ _bt_unlink_halfdead_page(Relation rel, B
 	 * And next write-lock the (current) right sibling.
 	 */
 	rightsib = opaque->btpo_next;
-	rbuf = _bt_getbuf(rel, rightsib, BT_WRITE);
+	rbuf = _bt_getbuf(rel, rightsib, BT_WRITE
+#ifdef USE_PREFETCH
+                                     , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                                );
 	page = BufferGetPage(rbuf);
 	opaque = (BTPageOpaque) PageGetSpecialPointer(page);
 	if (opaque->btpo_prev != target)
@@ -1731,7 +1964,11 @@ _bt_unlink_halfdead_page(Relation rel, B
 		if (P_RIGHTMOST(opaque))
 		{
 			/* rightsib will be the only one left on the level */
-			metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_WRITE);
+			metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_WRITE
+#ifdef USE_PREFETCH
+                                     , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                                );
 			metapg = BufferGetPage(metabuf);
 			metad = BTPageGetMeta(metapg);
 
--- src/backend/access/nbtree/nbtree.c.orig	2014-08-18 14:10:36.845016657 -0400
+++ src/backend/access/nbtree/nbtree.c	2014-08-19 16:56:13.979198218 -0400
@@ -29,6 +29,18 @@
 #include "tcop/tcopprot.h"
 #include "utils/memutils.h"
 
+#ifdef USE_PREFETCH
+extern unsigned int prefetch_index_scans; /* boolean whether to prefetch non-bitmap index scans also numeric size of pfch_list */
+#endif   /* USE_PREFETCH */
+
+Datum
+btpeeknexttuple(
+#ifdef AVOID_CATALOG_MIGRATION_FOR_ASYNCIO
+        IndexScanDesc scan
+#else /*  not AVOID_CATALOG_MIGRATION_FOR_ASYNCIO */
+        PG_FUNCTION_ARGS
+#endif /* not AVOID_CATALOG_MIGRATION_FOR_ASYNCIO */
+);
 
 /* Working state for btbuild and its callback */
 typedef struct
@@ -324,6 +336,78 @@ btgettuple(PG_FUNCTION_ARGS)
 }
 
 /*
+ *	btpeeknexttuple() -- peek at the next tuple different from any blocknum in pfch_block_item_list
+ *                           without reading a new index page
+ *                       and without causing any side-effects such as altering values in control blocks
+ *               if found,     store blocknum in next element of pfch_block_item_list
+ *      This function has no usefulness unless postgresql is compiled with USE_PREFETCH
+ */
+Datum
+btpeeknexttuple(
+#ifdef AVOID_CATALOG_MIGRATION_FOR_ASYNCIO
+        IndexScanDesc scan
+#else /*  not AVOID_CATALOG_MIGRATION_FOR_ASYNCIO */
+        PG_FUNCTION_ARGS
+#endif /* not AVOID_CATALOG_MIGRATION_FOR_ASYNCIO */
+)
+{
+#ifndef AVOID_CATALOG_MIGRATION_FOR_ASYNCIO
+    IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+#endif /* not AVOID_CATALOG_MIGRATION_FOR_ASYNCIO */
+	BTScanOpaque so = (BTScanOpaque) scan->opaque;
+	bool		res = false;
+	int		itemIndex;		/* current index in items[] */
+
+        
+#ifdef USE_PREFETCH
+        /*
+         * If we've already initialized this scan, we can just advance it in
+         * the appropriate direction.  If we haven't done so yet, bail out
+         */
+        if ( BTScanPosIsValid(so->currPos) ) {
+
+            itemIndex = so->currPos.itemIndex+1;    /*   next item */
+
+            /* This loop handles advancing till we find different data block or end of index page */
+            while (itemIndex <= so->currPos.lastItem) {
+                unsigned short int pfchx; /*  index in BlockIdData array   */
+                for (pfchx = 0; pfchx < scan->pfch_used; pfchx++) {
+                        if (BlockIdEquals((&(((scan->pfch_block_item_list)+pfchx)->pfch_blockid)) , &(so->currPos.items[itemIndex].heapTid.ip_blkid))) {
+                             goto block_match;
+                        }
+                }
+
+                /*  if we reach here,  no block in list matched this item  */
+                res = true;
+                /*   set item in prefetch list
+                **   prefer unused entry if there is one,  else overwrite
+                */
+                if (scan->pfch_used < prefetch_index_scans) {
+                    scan->pfch_next = scan->pfch_used;
+                } else {
+                    scan->pfch_next++;
+                    if (scan->pfch_next >= prefetch_index_scans) {
+                        scan->pfch_next = 0;
+                    }
+                }
+
+                BlockIdCopy((&((scan->pfch_block_item_list + scan->pfch_next)->pfch_blockid)) , &(so->currPos.items[itemIndex].heapTid.ip_blkid));
+                if (scan->pfch_used <= scan->pfch_next) {
+                     scan->pfch_used = (scan->pfch_next + 1);
+                }
+
+                goto peek_complete;
+
+      block_match:         itemIndex++;
+            }
+	}
+
+ peek_complete:
+#endif   /* USE_PREFETCH */
+	PG_RETURN_BOOL(res);
+}
+
+/*
  * btgetbitmap() -- gets all matching tuples, and adds them to a bitmap
  */
 Datum
@@ -417,6 +501,12 @@ btbeginscan(PG_FUNCTION_ARGS)
 	so->killedItems = NULL;		/* until needed */
 	so->numKilled = 0;
 
+	so->backSeqRun = 0;
+	so->backSeqPos = 0;
+	so->prefetchItemIndex = 0;
+	so->lastHeapPrefetchBlkno = P_NONE;
+	so->prefetchBlockCount = 0;
+	
 	/*
 	 * We don't know yet whether the scan will be index-only, so we do not
 	 * allocate the tuple workspace arrays until btrescan.  However, we set up
@@ -509,6 +599,23 @@ btendscan(PG_FUNCTION_ARGS)
 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
 	BTScanOpaque so = (BTScanOpaque) scan->opaque;
 
+#ifdef USE_PREFETCH
+        struct pfch_index_pagelist* pfch_index_plp;
+        int ix;
+
+	/* discard all prefetched but unread index pages listed in the pagelist */
+        pfch_index_plp = scan->pfch_index_page_list;
+        while ( (struct pfch_index_pagelist*)0 != pfch_index_plp ) {
+                    ix = pfch_index_plp->pfch_index_item_count;
+                    while (ix-- > 0) {
+                        if (pfch_index_plp->pfch_indexid[ix].pfch_discard) {
+                            DiscardBuffer( scan->indexRelation , MAIN_FORKNUM , pfch_index_plp->pfch_indexid[ix].pfch_blocknum);
+                        }
+                    }
+                    pfch_index_plp = pfch_index_plp->pfch_index_pagelist_next;
+        }
+#endif /* USE_PREFETCH */
+
 	/* we aren't holding any read locks, but gotta drop the pins */
 	if (BTScanPosIsValid(so->currPos))
 	{
--- src/backend/nodes/tidbitmap.c.orig	2014-08-18 14:10:36.877016807 -0400
+++ src/backend/nodes/tidbitmap.c	2014-08-19 16:56:14.063198519 -0400
@@ -44,6 +44,9 @@
 #include "nodes/bitmapset.h"
 #include "nodes/tidbitmap.h"
 #include "utils/hsearch.h"
+#ifdef USE_PREFETCH
+extern int	target_prefetch_pages;
+#endif   /* USE_PREFETCH */
 
 /*
  * The maximum number of tuples per page is not large (typically 256 with
@@ -572,7 +575,12 @@ tbm_begin_iterate(TIDBitmap *tbm)
 	 * needs of the TBMIterateResult sub-struct.
 	 */
 	iterator = (TBMIterator *) palloc(sizeof(TBMIterator) +
-								 MAX_TUPLES_PER_PAGE * sizeof(OffsetNumber));
+								 MAX_TUPLES_PER_PAGE * sizeof(OffsetNumber)
+#ifdef USE_PREFETCH
+                                          		      /*  space for remembering every prefetched but unread blockno */
+                                          		      +  (target_prefetch_pages * sizeof(BlockNumber))
+#endif   /* USE_PREFETCH */
+                                         );
 	iterator->tbm = tbm;
 
 	/*
@@ -1020,3 +1028,70 @@ tbm_comparator(const void *left, const v
 		return 1;
 	return 0;
 }
+
+#ifdef USE_PREFETCH
+void
+tbm_zero(TBMIterator *iterator) /* zero list of prefetched and unread blocknos */
+{
+      /* locate the list of prefetched but unread blocknos immediately following the array of offsets
+      ** and note that tbm_begin_iterate allocates space for (1 + MAX_TUPLES_PER_PAGE) offsets  -
+      ** 1 included in struct TBMIterator and MAX_TUPLES_PER_PAGE additional
+      */
+      iterator->output.Unread_Pfetched_base = ((BlockNumber *)(&(iterator->output.offsets[MAX_TUPLES_PER_PAGE+1])));
+      iterator->output.Unread_Pfetched_next = iterator->output.Unread_Pfetched_count = 0;
+}
+
+void
+tbm_add(TBMIterator *iterator, BlockNumber blockno) /* add this blockno to list of prefetched and unread blocknos */
+{
+      unsigned int Unread_Pfetched_index = iterator->output.Unread_Pfetched_next + iterator->output.Unread_Pfetched_count++;
+
+      if (iterator->output.Unread_Pfetched_count > target_prefetch_pages) {
+		ereport(ERROR,
+			(errcode(ERRCODE_INTERNAL_ERROR),
+                                errmsg("tbm_add overflowed list cannot add blockno %d", blockno)));
+      }
+
+      if (Unread_Pfetched_index >= target_prefetch_pages)
+          Unread_Pfetched_index -= target_prefetch_pages;
+      *(iterator->output.Unread_Pfetched_base + Unread_Pfetched_index) = blockno;
+}
+
+void
+tbm_subtract(TBMIterator *iterator, BlockNumber blockno) /* remove this blockno from list of prefetched and unread blocknos */
+{
+      unsigned int Unread_Pfetched_index = iterator->output.Unread_Pfetched_next++;
+      BlockNumber nextUnreadPfetched;
+
+      /*    make a weak check that the next blockno is the one to be removed,
+      **    although actually in case of disagreement,   we ignore callers blockno and remove next anyway,
+      **    which is really what caller wants
+      */
+      if ( iterator->output.Unread_Pfetched_count == 0 ) {
+		ereport(ERROR,
+			(errcode(ERRCODE_INTERNAL_ERROR),
+                                errmsg("tbm_subtract empty list cannot subtract blockno %d", blockno)));
+      }
+
+      if (Unread_Pfetched_index >= target_prefetch_pages)
+          Unread_Pfetched_index = 0;
+      nextUnreadPfetched = *(iterator->output.Unread_Pfetched_base + Unread_Pfetched_index);
+      if (   ( nextUnreadPfetched != blockno ) 
+          && ( nextUnreadPfetched != InvalidBlockNumber ) /* dont report it if the block in the list was InvalidBlockNumber */
+         ) {
+		ereport(NOTICE,
+			(errcode(ERRCODE_INTERNAL_ERROR),
+                                errmsg("tbm_subtract will subtract blockno %d not %d",
+					nextUnreadPfetched, blockno)));
+      }
+      if (iterator->output.Unread_Pfetched_next >= target_prefetch_pages)
+          iterator->output.Unread_Pfetched_next = 0;
+      iterator->output.Unread_Pfetched_count--;
+}
+#endif /* USE_PREFETCH */
+
+TBMIterateResult *
+tbm_locate_IterateResult(TBMIterator *iterator)
+{
+   return &(iterator->output);
+}
--- src/backend/utils/misc/guc.c.orig	2014-08-18 14:10:37.009017427 -0400
+++ src/backend/utils/misc/guc.c	2014-08-19 16:56:14.119198719 -0400
@@ -2258,6 +2258,25 @@ static struct config_int ConfigureNamesI
 	},
 
 	{
+		{"max_async_io_prefetchers",
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+			PGC_USERSET,
+#else
+			PGC_INTERNAL,
+#endif
+			RESOURCES_ASYNCHRONOUS,
+			gettext_noop("Maximum number of background processes concurrently using asynchronous librt threads to prefetch pages into shared memory buffers."),
+		},
+		&max_async_io_prefetchers,
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+	        -1, 0, 8192,      /*  boot val -1 indicates to initialize to something sensible during buf_init */
+#else
+		0, 0, 0,
+#endif
+		NULL, NULL, NULL
+	},
+
+	{
 		{"max_worker_processes",
 			PGC_POSTMASTER,
 			RESOURCES_ASYNCHRONOUS,
--- src/backend/utils/mmgr/aset.c.orig	2014-08-18 14:10:37.009017427 -0400
+++ src/backend/utils/mmgr/aset.c	2014-08-19 16:56:14.179198935 -0400
@@ -733,6 +733,48 @@ AllocSetAlloc(MemoryContext context, Siz
 	 */
 	fidx = AllocSetFreeIndex(size);
 	chunk = set->freelist[fidx];
+#ifdef MEMORY_CONTEXT_CHECKING
+        /*    an instance of segfault caused by a rogue value in set->freelist[fidx]
+        **    has been seen - check for it using crude sanity check based on neighbours :
+        **    if at least one is sufficiently close, then pass,  else fail
+        */
+        if (chunk != 0) {
+            int frx, nrx; /*  frx is index,  nrx is index of failing neighbour for errmsg */
+            for (nrx = -1, frx = 0; (frx < ALLOCSET_NUM_FREELISTS); frx++) {
+                if (   (frx != fidx)     /*  not the chosen one */
+                    && ( ( (unsigned long)(set->freelist[frx]) ) != 0 ) /* not empty */
+                   ) {
+                    if (   ( (unsigned long)chunk < ( ( (unsigned long)(set->freelist[frx]) ) / 2 ) )
+                        && (  ( (unsigned long)(set->freelist[frx]) ) < 0x4000000  )
+               /***     || ( (unsigned long)chunk > ( ( (unsigned long)(set->freelist[frx]) ) * 2 ) )  ***/
+                       ) {
+                       nrx = frx;
+                    } else {
+                       nrx = -1;
+                       break;
+                    }
+                }
+            }
+
+            if (nrx >= 0) {
+                     /*  this must be a rogue value  -  put this list in the garbage */
+                     /*  build message but be careful to avoid recursively triggering same fault */
+                     set->freelist[fidx] = NULL;   /*  mark this list empty */
+                     elog(WARNING, "detected rogue value %p in freelist index %d compared with neighbour %p whose chunksize %d"
+				 , chunk , fidx , set->freelist[nrx] , set->freelist[nrx]->size);
+                     chunk = NULL;
+            }
+        }
+#else /* if not MEMORY_CONTEXT_CHECKING make very simple-minded check*/
+        if ( (chunk != 0) && ( (unsigned long)chunk <  0x40000 ) ) {
+                     /*  this must be a rogue value  -  put this list in the garbage */
+                     /*  build message but be careful to avoid recursively triggering same fault */
+                     set->freelist[fidx] = NULL;   /*  mark this list empty */
+                     elog(WARNING, "detected rogue value %p in freelist index %d"
+				 , chunk , fidx);
+                     chunk = NULL;
+        }
+#endif
 	if (chunk != NULL)
 	{
 		Assert(chunk->size >= size);
--- src/include/executor/instrument.h.orig	2014-08-18 14:10:37.057017653 -0400
+++ src/include/executor/instrument.h	2014-08-19 16:56:14.427199824 -0400
@@ -28,8 +28,18 @@ typedef struct BufferUsage
 	long		local_blks_written;		/* # of local disk blocks written */
 	long		temp_blks_read; /* # of temp blocks read */
 	long		temp_blks_written;		/* # of temp blocks written */
+
 	instr_time	blk_read_time;	/* time spent reading */
 	instr_time	blk_write_time; /* time spent writing */
+
+	long		aio_read_noneed;		/* # of prefetches for which no need for prefetch as block already in buffer pool */
+	long		aio_read_discrd;		/* # of prefetches for which no need for prefetch as block already in buffer pool */
+	long		aio_read_forgot;		/* # of prefetches for which no need for prefetch as block already in buffer pool */
+	long		aio_read_noblok;		/* # of prefetches for which no available BufferAiocb */
+	long		aio_read_failed;		/* # of aio reads for which aio itself failed or the read failed with an errno */
+	long		aio_read_wasted;		/* # of aio reads for which disk block not used */
+	long		aio_read_waited;		/* # of aio reads for which disk block used but had to wait for it */
+	long		aio_read_ontime;		/* # of aio reads for which disk block used and ready on time when requested */
 } BufferUsage;
 
 /* Flag bits included in InstrAlloc's instrument_options bitmask */
--- src/include/storage/bufmgr.h.orig	2014-08-18 14:10:37.065017690 -0400
+++ src/include/storage/bufmgr.h	2014-08-19 16:56:14.455199924 -0400
@@ -41,6 +41,7 @@ typedef enum
 	RBM_ZERO_ON_ERROR,			/* Read, but return an all-zeros page on error */
 	RBM_NORMAL_NO_LOG			/* Don't log page as invalid during WAL
 								 * replay; otherwise same as RBM_NORMAL */
+       ,RBM_NOREAD_FOR_PREFETCH   /* Don't read from disk, don't zero buffer, find buffer only */
 } ReadBufferMode;
 
 /* in globals.c ... this duplicates miscadmin.h */
@@ -57,6 +58,9 @@ extern int	target_prefetch_pages;
 extern PGDLLIMPORT char *BufferBlocks;
 extern PGDLLIMPORT int32 *PrivateRefCount;
 
+/*  in buf_async.c  */;
+extern int      max_async_io_prefetchers; /* Maximum number of backends using asynchronous librt threads to read pages into our buffers */
+
 /* in localbuf.c */
 extern PGDLLIMPORT int NLocBuffer;
 extern PGDLLIMPORT Block *LocalBufferBlockPointers;
@@ -159,9 +163,15 @@ extern PGDLLIMPORT int32 *LocalRefCount;
 #define BufferGetPage(buffer) ((Page)BufferGetBlock(buffer))
 
 /*
- * prototypes for functions in bufmgr.c
+ * prototypes for external functions in bufmgr.c and buf_async.c
  */
-extern void PrefetchBuffer(Relation reln, ForkNumber forkNum,
+extern int PrefetchBuffer(Relation reln, ForkNumber forkNum,
+			   BlockNumber blockNum , BufferAccessStrategy strategy);
+/*   return code  is an int bitmask : */
+#define PREFTCHRC_BUF_PIN_INCREASED 0x01    /*  pin count on buffer has been increased by 1 */
+#define PREFTCHRC_BLK_ALREADY_PRESENT 0x02  /*  block was already present in a buffer       */
+
+extern void DiscardBuffer(Relation reln, ForkNumber forkNum,
 			   BlockNumber blockNum);
 extern Buffer ReadBuffer(Relation reln, BlockNumber blockNum);
 extern Buffer ReadBufferExtended(Relation reln, ForkNumber forkNum,
